function love.load()
	require "gradient"
	
	speed = 50
	posx = 400-50
	posy = 300-50
	width = 100
	height = 100
	rot = 0
	mode = "linear"
	
	color1 = {205, 255, 0, 255}
	color2 = {0, 205, 255, 255}
end

function love.update(dt)
	local dt = math.min(dt, 1/60)
	local down = love.keyboard.isDown
	if down("d") then
		posx = posx + dt*speed
	end
	if down("a") then
		posx = posx - dt*speed
	end
	if down("s") then
		posy = posy + dt*speed
	end
	if down("w") then
		posy = posy - dt*speed
	end
	if down("q") then
		rot = rot + math.pi/4*dt
	end
	if down("e") then
		rot = rot - math.pi/4*dt
	end
	rot = math.mod(rot, math.pi*2)
	if rot < 0 then rot = rot+math.pi*2 end
end

function love.draw()
	local x1, y1 = posx+width/2+math.cos(rot+math.pi*.25)*(width/2), posy+height/2+math.sin(rot+math.pi*.25)*(height/2)
	local x2, y2 = posx+width/2+math.cos(rot+math.pi*.75)*(width/2), posy+height/2+math.sin(rot+math.pi*.75)*(height/2)
	local x3, y3 = posx+width/2+math.cos(rot+math.pi*1.25)*(width/2), posy+height/2+math.sin(rot+math.pi*1.25)*(height/2)
	local x4, y4 = posx+width/2+math.cos(rot+math.pi*1.75)*(width/2), posy+height/2+math.sin(rot+math.pi*1.75)*(height/2)
	local f = function()
		love.graphics.polygon("fill", x1, y1, x2, y2, x3, y3, x4, y4)
	end
	love.gradient.draw(f, mode, posx+width/2, posy+height/2, width, height, color1, color2, rot)
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.polygon("line", x1, y1, x2, y2, x3, y3, x4, y4)
end

function love.keypressed(key, unicode)
	if key == "escape" then
		love.event.quit()
	elseif key == "tab" then
		local n = 1
		local nxt = false
		for i, v in ipairs(love.gradient.types) do
			if nxt then
				n = i
				break
			elseif v == mode then
				nxt = true
			end
		end
		mode = love.gradient.types[n]
	end
end